//
// File: checkbox.cc
// Checkbox-class for SDL
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Wed Nov  3 00:19:46 2004
//
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#include "checkbox.h"

//do not use!
checkbox::checkbox()
{
	// TODO: put constructor code here
}

//alternative constructor
checkbox::checkbox(int x_pos, int y_pos,const char* up_image,const char* down_image, bool check)
{
	checked = check;
	disabled = false;
	
	back=NULL;
	x =	x_pos;
	y = y_pos;
	image_d = IMG_Load(down_image);
	image_u = IMG_Load(up_image);
	w = image_d->w;
	h = image_d->h;	
}

//alternative constructor
checkbox::checkbox(SDL_Surface* src, int x_pos, int y_pos,const char* up_image,const char* down_image, bool check)
{
	SDL_Rect dstrect;
	
	dstrect.x = x_pos;
	dstrect.y = y_pos;

	checked = check;
	disabled = false;
	back = IMG_Load(down_image);

	x =	x_pos;
	y = y_pos;
	image_d = IMG_Load(down_image);
	image_u = IMG_Load(up_image);
	w = image_d->w;
	h = image_d->h;	

	dstrect.w = image_u->w;
	dstrect.h = image_u->h;

//	back = SDL_CreateRGBSurface(0, w, h, 16, 0x00000000, 0x00000000, 0x00000000, 0x00000000);
	SDL_BlitSurface(src, &dstrect, back, NULL);
	SDL_UpdateRect(back, 0,	0, dstrect.w, dstrect.h );
}

//destructor
checkbox::~checkbox()
{
	SDL_FreeSurface(image_d);
	SDL_FreeSurface(image_u);
	if(back!=NULL)
		SDL_FreeSurface(back);
	// TODO: put destructor code here
}

//updates image-to on/off
void checkbox::update(SDL_Surface* destination)
{
	SDL_Rect dstrect;
	
	dstrect.x = x;
	dstrect.y = y;
	dstrect.w = image_u->w;
	dstrect.h = image_u->h;

	if(back!=NULL)
		SDL_BlitSurface(back, NULL, destination, &dstrect);

	if( !checked )
		SDL_BlitSurface( image_u, NULL, destination, &dstrect);
	else
		SDL_BlitSurface( image_d, NULL, destination, &dstrect);

	SDL_UpdateRect(destination, dstrect.x,	dstrect.y, dstrect.w, dstrect.h );
}

//method to on mouse click
void checkbox::onMouseClick(int mx, int my, SDL_Surface* screen)
{

	#ifdef DEBUG
		cout << mx <<","<< my<<"," << x<<"," << y<<"," << image_d->w<<"," << image_d->h << endl;
	#endif
	
	if( (mx > x) && (mx < (x+image_d->w) ) && 
		(my > y) && (my < (y+image_d->h) ))
	{
		checked = !checked;
		update( screen );
	}
		

}

//is checked on
bool checkbox::isChecked()
{
	return checked;	
}

//toggles checked
void checkbox::toggleCheck()
{
	checked=!checked;	
}

//updates pictures in checkbox
void checkbox::updatePictures(const char* up_image,const  char* down_image)
{
	SDL_FreeSurface(image_d);
	SDL_FreeSurface(image_u);

/*	if(back!=NULL)
		SDL_BlitSurface(back, NULL, destination, &dstrect);
*/
	image_d = IMG_Load(down_image);
	image_u = IMG_Load(up_image);
}

// FIXME
//disables checkbox
void checkbox::disable(SDL_Surface* destination)
{
	disabled=true;	
}

// FIXME
//enables checkbox
void checkbox::enable(SDL_Surface* destination)
{
	disabled=false;	
}

// return is checkbox enabled
bool checkbox::isEnabled(void)
{
	return !disabled;	
}

// sets checked true
void checkbox::setCheck()
{
	checked = true;	
}
