//
// File: checkbox.h
// Checkbox-class for SDL
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Wed Nov  3 00:19:46 2004
//
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#ifndef _CHECKBOX_H_
#define _CHECKBOX_H_

#include <SDL.h>
#include <SDL_image.h>

class checkbox
{
	
	private:
		SDL_Surface* image_d;
		SDL_Surface* image_u;
		SDL_Surface* back;
		int x, y, w, h;
		bool checked;
		bool disabled;

	public:
		checkbox();
		checkbox( int x_pos, int y_pos, const char* up_image,const char* down_image, bool check);
		checkbox(SDL_Surface* src, int x_pos, int y_pos,const char* up_image,const char* down_image, bool check);
		 ~checkbox();
		void update(SDL_Surface* destination);
		void onMouseClick(int mx, int my, SDL_Surface* screen);
		bool isChecked();
		void toggleCheck();
		void updatePictures(const char* up_image,const char* down_image);
		void disable(SDL_Surface* destination);
		void enable(SDL_Surface* destination);	
		bool isEnabled(void);	
		void setCheck();
		// checkbox interface
	
		// TODO: add member function declarations...
	
	protected:
		// checkbox variables
	
		// TODO: add member variables...
	
};


#endif	//_CHECKBOX_H_
