//
// File: file.h
// file class, handles files
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Wed Nov  3 17:26:03 2004
//

#ifndef _FILE_H_
#define _FILE_H_

#include <sys/stat.h>
#include <sys/types.h>

#include <cstring>
#include <cstdio>
#include <string>
#include <iostream>
using namespace std;
#include <fstream>

#include "game.h"
#include "hiScore.h"
#include "defines.h"
#define MAX_TEXT_FILE 80

class file
{
	private:
		string configFile;
		game* yGame;
		hiScore* hiscores;
	public:
		file();
		 ~file();
		int checkConfig();
		void readConfig();
		void writeConfig();
		game *getGame();
		hiScore* getHiscore();

//		void createHiscoreFile();	it's after installation there
		void readHiscores();
		void writeHiscores();

};


#endif	//_FILE_H_
