//
// File: game.cc
// The actual game-engine
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Wed Nov  3 14:41:48 2004
//


#include "game.h"


game::game()
{
	int i;
#ifdef MACOSX
	srandom( (unsigned int)( SDL_GetTicks() )); // set seed from time in mseconds
#else
	srand( (unsigned int)( SDL_GetTicks() )); // set seed from time in mseconds
#endif
	for(i=0; i< MAX_PLAYERS; i++)
		players[i] = new player;
//	for(i=0; i< MAX_DICES; i++)
//		dices[i] = (i+1);
/*	for(i=0; i< MAX_PLAYERS; i++)
		players[i]->onGame = true; //this should read from disk
	*/
	round = 0;
	pRound = 0;
	round=4;
#ifdef DEBUG
	cout << "total y: " << MTOTAL_Y << endl;
#endif

}


game::~game()
{
		int i;
	for(i=0; i< MAX_PLAYERS; i++)
		delete players[i];
	// TODO: put destructor code here
}

int game::rndDice(int diceNbr)
{
	int i;
	
	//cout << "TICKS: " << SDL_GetTicks() << endl;
#ifdef MACOSX
//	srandom( (unsigned int)( SDL_GetTicks() )); // set seed from time in mseconds

	usleep(100);
	i = random()%6+1;
// i = 1+(int)(6.0*(float)random()/(RAND_MAX+1.0));
#elif WIN32
/*	srand( (unsigned int)( SDL_GetTicks() )); // set seed from time in mseconds
	// Hack to get random numbers. OH why????
    rand();
    rand();
    rand();
    Sleep(1);
	i = 1+(int)(6.0*(float)rand()/(RAND_MAX+1.0));*/
	Sleep(10);
	i = rand()%6+1;
#else
/*	srand( (unsigned int)( SDL_GetTicks() )); // set seed from time in mseconds
	usleep(100);
	i = 1+(int)(6.0*rand()/(RAND_MAX+1.0));
*/
	usleep(100);
	i = rand()%6+1;
#endif
	//cout << "i:" << i << endl;
	
	return i;	
}

int game::decPlayerRound()
{
	
	pRound--;
	return pRound;
}


int game::getPlayerRound(void)
{
	return pRound;
}

void game::changePlayer(void)
{
	pRound = MAX_THROWS;
	round--;
		
	//changes currentPlayer
	while(1)
	{
		cPlayer++;
		if(cPlayer==MAX_PLAYERS)
			cPlayer=0;

		if(players[cPlayer]->onGame)
			break;
	}					
						
}


int game::getRound(void)
{
#ifdef DEBUG
	cout << round << endl;
#endif
	return round;
}

bool game::playerIsOnGame(int i)
{
	return players[i]->onGame;	
}

void game::setConfig(int fs,int* po,const char *pn)
{
	int i,j;
	
	cPlayer=0;
	pRound=MAX_THROWS;
	fullscreen = (bool)fs;
	
	for(i=0; i < MAX_PLAYERS; i++)
	{
		for(j=0;j<MISSIONS;j++)
		{
			players[i]->haveM[j]=false;
			players[i]->M[j]=0;
		}
		players[i]->upperPoints=0;
		players[i]->totalPoints=0;
		players[i]->bonus=0;
		players[i]->onGame = (bool)po[i];
		strcpy(players[i]->name,&pn[i*MAX_TEXT_REALLY]);
#ifdef DEBUG
		cout << players[i]->name << endl;
		cout << players[i]->onGame << endl;
#endif
	}

	for(i=0; i < MAX_PLAYERS; i++)
		if(players[i]->onGame)
		{
			firstPlayer=i;
			break;
		}
		
}

int game::getFullscreen()
{
	return (int)fullscreen;	
}

char* game::getName(int i)
{
	return players[i]->name;
}

int game::getCurrentPlayer()
{
	//cout << cPlayer << endl;
	return cPlayer;	
}

//sets totalPlayers and rounds
void game::setTotalPlayers()
{
	int i;
	
	totalPlayers=0;
	for(i=0; i < MAX_PLAYERS; i++)
		if(players[i]->onGame)
			totalPlayers++;
	round = totalPlayers*MISSIONS;
}

int game::getFirstPlayer()
{
	//cout << firstPlayer << endl;
	return firstPlayer;	
}

void game::setFirstPlayer(void)
{
	int i;
	//cout << firstPlayer << endl;
	for(i=0; i < MAX_PLAYERS; i++)
		if(players[i]->onGame)
		{
			firstPlayer=i;
			cPlayer=i;
			break;
		}	
}
bool game::getPlayerHaveM(int i, int j)
{
	return players[i]->haveM[j];
}

void game::setPlayerHaveM(int i, int j, bool val)
{
	players[i]->haveM[j]=val;
}

int game::getPlayerM(int i, int j)
{
	return players[i]->M[j];
}

void game::setPlayerM(int i, int j, int sum)
{
	players[i]->M[j]=sum;
	
	players[i]->totalPoints = players[i]->totalPoints+sum;
#ifdef DEBUG
	cout << "totalPoints: " << players[i]->totalPoints << endl;
#endif
	if(j<SIX)
		players[i]->upperPoints += sum;
}

int game::getPlayerUTotal(int i)
{
	return players[i]->upperPoints;
}

int game::getPlayerTotal(int i)
{
	return players[i]->totalPoints;
}

void game::setBonus(int i)
{
	if(players[i]->bonus!=BONUS_VAL)
	{
		players[i]->bonus=BONUS_VAL;	
		players[i]->upperPoints += BONUS_VAL;
		players[i]->totalPoints += BONUS_VAL;
	}
}

void game::initPlayerTotals(int i)
{
	players[i]->totalPoints = 0;
	players[i]->upperPoints = 0;
}
