//
// File: game.h
// The actual game-engine
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Wed Nov  3 14:41:48 2004
//

#ifndef _GAME_H_
#define _GAME_H_

#include <SDL/SDL.h>
#include <stdlib.h>
#include <time.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <cstring>
#include <iostream>
using namespace std;

#include "defines.h"

//#define MAX_TEXT_REALLY 21 //I don't know why this. Structure player don't accept defines.h
#include "player.h"

class game
{
	private:
		//int dices[MAX_DICES];
		int pRound, round, cPlayer, totalPlayers, firstPlayer;
		player* players[MAX_PLAYERS];
		bool fullscreen;
	public:
		game();
		 ~game();
		int rndDice(int diceNbr);
		void setConfig(int fs,int *po,const  char *pn);
		int getFullscreen();
	
		int decPlayerRound();	
		int getPlayerRound(void);
		void changePlayer(void);
		int getRound(void);
		void setRound(int sRound);

		bool playerIsOnGame(int i);
		char* getName(int i);
		int getCurrentPlayer();
		void setTotalPlayers();
		int getFirstPlayer();
		void setFirstPlayer(void);

		bool getPlayerHaveM(int i, int j);
		void setPlayerHaveM(int i, int j, bool val);
		int getPlayerM(int i, int j);
		void setPlayerM(int i, int j, int sum);

		void setBonus(int i);

		int getPlayerUTotal(int i);
		int getPlayerTotal(int i);
		
		void initPlayerTotals(int i);
};

#endif	//_GAME_H_
