//
// File: itextbox.h
// inputtextbox class for SDL
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Tue Nov  2 14:51:36 2004
//
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#ifndef _ITEXTBOX_H_
#define _ITEXTBOX_H_

#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>

#include <cstring>
#include <iostream>
using namespace std;

#include "defines.h"

/*#define MAX_TEXT_REALLY 21
#define MAX_TEXT 255
*/

class itextbox
{
	private:
		SDL_Surface* background;
		SDL_Color fontcolor;
	
		bool active; // is textbox active
		int x, y, w, h, size;
		TTF_Font *font;
		char text[MAX_TEXT];
		string fn_font1;
	
	public:
		itextbox();
		itextbox( int x_pos, int y_pos, int tsize, const char* bg);
		 ~itextbox();
		void update(SDL_Surface* destination);
		void onMouseClick(int mx, int my, SDL_Surface *screen);
		void edit(SDL_KeyboardEvent* key, SDL_Surface* screen);
		char *getText();
		void setText(char* eText);
		void isActive(SDL_Surface* screen);

	
};


#endif	//_ITEXTBOX_H_
