//
// File: mSDL.cc
// SDL class, handles userinterface
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Sat Oct 30 22:28:05 2004
//
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#include "mSDL.h"

mSDL::mSDL()
{}
	
// Compose datanames
// Alloc memory and creates components
mSDL::mSDL(file* tFile)
{
//	int i;
	// init picturenames
	// (have to because you can install data allmost anywhere)

	string theme = "/default";

#ifndef WIN32
	string datadir = DATADIR + theme;
#else
	string datadir = DATADIR_WIN32 + theme;
#endif

	pn_quit = datadir + PIC_QUIT;
	pn_winner = datadir + PIC_GAME;
	
	pn_startDown = datadir + PIC_STARTDOWN;
	pn_startUp = datadir + PIC_STARTUP;
	pn_quitUp = datadir + PIC_QUITUP;
	pn_quitDown = datadir + PIC_QUITDOWN;
	pn_configUp = datadir + PIC_CONFIGUP;
	pn_configDown = datadir + PIC_CONFIGDOWN;

	pn_okUp = datadir + PIC_OKUP;
	pn_okDown = datadir + PIC_OKDOWN;
	pn_backUp = datadir + PIC_BACKUP;
	pn_backDown = datadir + PIC_BACKDOWN;
	pn_throwUp = datadir + PIC_THROWUP;
	pn_throwDown = datadir + PIC_THROWDOWN;
	pn_cancelDown = datadir + PIC_CANCELDOWN;
	pn_cancelUp = datadir + PIC_CANCELUP;

	pn_checkDown = datadir + PIC_CHECKDOWN;
	pn_checkUp = datadir + PIC_CHECKUP;

	//picture names for 1-6
	pn_M[0][0] = datadir + PIC_M1DOWN;
	pn_M[0][1] = datadir + PIC_M1UP;
	pn_M[1][0] = datadir + PIC_M2DOWN;
	pn_M[1][1] = datadir + PIC_M2UP;
	pn_M[2][0] = datadir + PIC_M3DOWN;
	pn_M[2][1] = datadir + PIC_M3UP;
	pn_M[3][0] = datadir + PIC_M4DOWN;
	pn_M[3][1] = datadir + PIC_M4UP;
	pn_M[4][0] = datadir + PIC_M5DOWN;
	pn_M[4][1] = datadir + PIC_M5UP;
	pn_M[5][0] = datadir + PIC_M6DOWN;
	pn_M[5][1] = datadir + PIC_M6UP;

	//picture names for pairs
	pn_M[6][0] = datadir + PIC_M1PDOWN;
	pn_M[6][1] = datadir + PIC_M1PUP;
	pn_M[7][0] = datadir + PIC_M2PDOWN;
	pn_M[7][1] = datadir + PIC_M2PUP;
	pn_M[8][0] = datadir + PIC_M3PDOWN;
	pn_M[8][1] = datadir + PIC_M3PUP;

	//picture names for saims
	pn_M[9][0] = datadir + PIC_M3SDOWN;
	pn_M[9][1] = datadir + PIC_M3SUP;
	pn_M[10][0] = datadir + PIC_M4SDOWN;
	pn_M[10][1] = datadir + PIC_M4SUP;
	pn_M[11][0] = datadir + PIC_M5SDOWN;
	pn_M[11][1] = datadir + PIC_M5SUP;

	//straight pics
	pn_M[12][0] = datadir + PIC_MSSDOWN;
	pn_M[12][1] = datadir + PIC_MSSUP;
	pn_M[13][0] = datadir + PIC_MLSDOWN;
	pn_M[13][1] = datadir + PIC_MLSUP;
	pn_M[14][0] = datadir + PIC_MFSDOWN;
	pn_M[14][1] = datadir + PIC_MFSUP;

	//other pics
	pn_M[15][0] = datadir + PIC_MHUTDOWN;
	pn_M[15][1] = datadir + PIC_MHUTUP;
	pn_M[16][0] = datadir + PIC_MHOUDOWN;
	pn_M[16][1] = datadir + PIC_MHOUUP;
	pn_M[17][0] = datadir + PIC_MTOWDOWN;
	pn_M[17][1] = datadir + PIC_MTOWUP;
	pn_M[18][0] = datadir + PIC_MCHADOWN;
	pn_M[18][1] = datadir + PIC_MCHAUP;
	pn_M[19][0] = datadir + PIC_MYDOWN;
	pn_M[19][1] = datadir + PIC_MYUP;

	pn_dUp[0] = datadir + PIC_D1UP;
	pn_dDown[0] = datadir + PIC_D1DOWN;
	pn_dUp[1] = datadir + PIC_D2UP;
	pn_dDown[1] = datadir + PIC_D2DOWN;
	pn_dUp[2] = datadir + PIC_D3UP;
	pn_dDown[2] = datadir + PIC_D3DOWN;
	pn_dUp[3] = datadir + PIC_D4UP;
	pn_dDown[3] = datadir + PIC_D4DOWN;
	pn_dUp[4] = datadir + PIC_D5UP;
	pn_dDown[4] = datadir + PIC_D5DOWN;
	pn_dUp[5] = datadir + PIC_D6UP;
	pn_dDown[5] = datadir + PIC_D6DOWN;
	
	pn_itext1 = datadir + PIC_ITEXT1;
	//font names
	fn_font1 = datadir + FONT1_NAME;
	
	/*
	dCheck[0] = new dice(1, D1_X, D1_Y, pn_dUp[0].c_str(), pn_dDown[0].c_str(), false );
	dCheck[1] = new dice(2, D2_X, D2_Y, pn_dUp[1].c_str(), pn_dDown[1].c_str(), false );
	dCheck[2] = new dice(3, D3_X, D3_Y, pn_dUp[2].c_str(), pn_dDown[2].c_str(), false );
	dCheck[3] = new dice(4, D4_X, D4_Y, pn_dUp[3].c_str(), pn_dDown[3].c_str(), false );
	dCheck[4] = new dice(5, D5_X, D5_Y, pn_dUp[4].c_str(), pn_dDown[4].c_str(), false );
	dCheck[5] = new dice(6, D6_X, D6_Y, pn_dUp[5].c_str(), pn_dDown[5].c_str(), false );
	*/

	// read configfile now or earlier
//	yGame = new game();
	yFile = tFile;
	yHiscore = yFile->getHiscore();
#ifdef DEBUG
	cout << "mySDL const" << endl;
#endif

}

// deletes components
mSDL::~mSDL()
{

}

// inits SDL and opens screen
int mSDL::initScreen(game *mGame)
{
#ifdef DEBUG
	cout << "initscreen beg" << endl;
#endif

	int i;
	yGame = mGame;
	
	flags = SDL_SWSURFACE;
	width = 800;
	height = 600;
	bpp = 16;
	
	if(yGame->getFullscreen())
		flags = flags|SDL_FULLSCREEN;
	if( SDL_Init(SDL_INIT_VIDEO) < 0 )
	{
		return 0;
	}
	else if( ( screen = SDL_SetVideoMode( width, height, bpp, flags )) == NULL)
	{
		return 0;
	}
	SDL_EnableUNICODE( 1 );
	SDL_WM_SetCaption(GAME_NAME, GAME_NAME);

	
//	cout << "initscreen mid1:" << pn_startUp.c_str() << endl;
	

	
//	mTxt=new statictext(screen, ((i*DSTM_X)+STM1_X), (M1_Y+(j*DM)),ITEXT1_SIZE,fn_font1.c_str(), "P");
	bStart = new button(START_X, START_Y, pn_startUp.c_str(), pn_startDown.c_str() );
	bQuit = new button(QUIT_X, QUIT_Y, pn_quitUp.c_str(), pn_quitDown.c_str() );
	bConfig = new button(CONFIG_X, CONFIG_Y, pn_configUp.c_str(), pn_configDown.c_str());
//	cout << "initscreen mid2" << endl;

	// buttons to select mission
	for(i=0;i<SIX;i++)
		bM[i] = new button(M1_X, M1_Y+(i*DM), pn_M[i][1].c_str(), pn_M[i][0].c_str() );
	for(i=SIX;i<TOWER;i++)
		bM[i] = new button(M1_X, M1_Y+(i*DM)+(TWO*DM), pn_M[i][1].c_str(), pn_M[i][0].c_str() );
//	cout << "initscreen mid3" << endl;

	bOK = new button(OK_X, OK_Y, pn_okUp.c_str(), pn_okDown.c_str() );
	bBack = new button(BACK_X, BACK_Y, pn_backUp.c_str(), pn_backDown.c_str() );
	bCancel = new button(CANCEL_X, CANCEL_Y, pn_cancelUp.c_str(),pn_cancelDown.c_str() );
	bThrow = new button(THROW_X, THROW_Y, pn_throwUp.c_str(), pn_throwDown.c_str() );
//	cout << "initscreen mid4" << endl;

	iText[0] = new itextbox( ITEXT1_X, ITEXT1_Y, ITEXT1_SIZE, pn_itext1.c_str());
	iText[1] = new itextbox( ITEXT1_X, ITEXT2_Y, ITEXT1_SIZE, pn_itext1.c_str());
	iText[2] = new itextbox( ITEXT1_X, ITEXT3_Y, ITEXT1_SIZE, pn_itext1.c_str());
	iText[3] = new itextbox( ITEXT1_X, ITEXT4_Y, ITEXT1_SIZE, pn_itext1.c_str());
//	cout << "initscreen mid5" << endl;

	for(i=0;i<MAX_HISCORES;i++)
		hiText[i] = NULL;
//		cout << "initscreen mid6" << endl;

	tmp = SDL_CreateRGBSurface(flags, width, height, bpp, 0x00000000, 0x00000000, 0x00000000, 0x00000000);
//	cout << "initscreen end" << endl;
	return 1;	
}

// quits SDL
int mSDL::closeScreen()
{
//	cout << "closeScreen beg" << endl;
	int i;
	//j;
	// statictexts
	
	// buttons
	delete bStart;
	delete bQuit;
	delete bConfig;
	delete bThrow;

	for(i=0;i<TOWER;i++)
		delete bM[i];
	
	delete bOK;
	delete bBack;
	delete bCancel;
	
	//inputfields & checkboxs
	for(i=0;i<MAX_PLAYERS;i++)
	{
		delete iText[i];
	}

	
	


	SDL_FreeSurface(screen);
	SDL_FreeSurface(tmp);
	SDL_Quit();
//	cout << "closeScreen end" << endl;
	return 1;	
}

// draws picture on screen
int mSDL::drawScreen(const char* pic)
{
	SDL_Surface *scr = IMG_Load( pic );
	if( !scr )
	{
		return 0;	
	}
	if( SDL_BlitSurface( scr, NULL, screen, NULL ) < 0 )
	{
		return 0;
	}
	SDL_UpdateRect(screen, 0,0,0,0 );
	
	SDL_FreeSurface( scr );
	
	return 1;
}

//mainmenu
int mSDL::handleMainmenu()
{
	sHiText = new statictext(screen, SHITEXT_X, SHITEXT_Y, SHITEXT_SIZE, fn_font1.c_str() ,"Top 20:");
	
	bStart->update( screen );
	bQuit->update( screen );
	bConfig->update( screen );
	sHiText->update( screen );
	int sdl_quit=0;
	int i=0;

	for(i=0;i<MAX_HISCORES;i++)
	{
		//cout << yHiscore->getScore(i) << endl;
		drawHiscore( yHiscore->getScore(i), yHiscore->getName(i), i );
	}
	
	while(sdl_quit < 1)
	{
#ifndef WIN32
		usleep(USLEEP);
#else
        Sleep(1);
#endif
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					sdl_quit = WQUIT;
					break;
				case SDL_MOUSEBUTTONDOWN:
					bStart->isPressed(event.button.x, event.button.y, screen);
					bQuit->isPressed(event.button.x, event.button.y, screen);				
					bConfig->isPressed(event.button.x, event.button.y, screen);				
					break;
				case SDL_MOUSEBUTTONUP:
					if( bStart->isReleased(event.button.x, event.button.y, screen) )
					{
						sdl_quit = START;
					}
					if( bQuit->isReleased(event.button.x, event.button.y, screen) )
					{
						sdl_quit = QUIT;
					}
					if( bConfig->isReleased(event.button.x, event.button.y, screen) )
					{
						sdl_quit = CONFIG;
					}

					break;		
				default:
					break;					
			}				
		}			
	}
	
	delete sHiText;
	
	for(i=0;i<MAX_HISCORES;i++)
	{
		if( hiText[i] != NULL )
		{
			delete hiText[i];
			delete hiText2[i];
//			delete hiText0[i];
			hiText[i]=NULL;
		}
	}
	
	return sdl_quit;
}


// Gamescreen
int mSDL::handleGameScreen()
{
/*	bStart->update( screen );
*/
	int j,hc,total,utotal,anim,i=0;
	int game_quit=0;
	int game_quit2=0; 
	int currentPlayer, currentRound;
	bool disabled=false;
	bool firstThrow=true;
	bool toTheList=false;

	// results to char
	char result[3];
	char cTotal[3];
	char cUTotal[3];
	
	int gDice[MAX_DICES];

	testresult* testing = new testresult;
	
	sM[0] = new statictext(screen, M1_X, TBONUS_Y, ITEXT2_SIZE, fn_font1.c_str() ,"Bonus:");
	sM[1] = new statictext(screen, M1_X, TUTOTAL_Y, ITEXT2_SIZE, fn_font1.c_str() ,"Upper total:");
	sM[2] = new statictext(screen, M1_X, MTOTAL_Y, ITEXT1_SIZE, fn_font1.c_str() ,"Total:");

	dCheck[0] = new dice(screen, 1, D1_X, D1_Y, pn_dUp[0].c_str(), pn_dDown[0].c_str(), false );
	dCheck[1] = new dice(screen, 2, D2_X, D2_Y, pn_dUp[1].c_str(), pn_dDown[1].c_str(), false );
	dCheck[2] = new dice(screen, 3, D3_X, D3_Y, pn_dUp[2].c_str(), pn_dDown[2].c_str(), false );
	dCheck[3] = new dice(screen, 4, D4_X, D4_Y, pn_dUp[3].c_str(), pn_dDown[3].c_str(), false );
	dCheck[4] = new dice(screen, 5, D5_X, D5_Y, pn_dUp[4].c_str(), pn_dDown[4].c_str(), false );
	dCheck[5] = new dice(screen, 6, D6_X, D6_Y, pn_dUp[5].c_str(), pn_dDown[5].c_str(), false );
	
	for(i=0;i<MAX_PLAYERS;i++)	
		mTxt[i][0] = new statictext(screen, (i*DSTM_X+STM1_X), (STM1_Y-5),ITEXT1_SIZE,fn_font1.c_str(), yGame->getName(i));

	for(i=0;i<MAX_PLAYERS;i++)
	{
		yGame->initPlayerTotals(i);
		for(j=1; j<MISSIONS_ALL; j++)
				mTxt[i][j] = new statictext(screen, (i*DSTM_X+STM1_X), (j*DM+STM1_Y),ITEXT3_SIZE,fn_font1.c_str(), "-");
	}		
	for(i=0; i < MAX_DICES;i++ )
	{
		dCheck[i]->updateValue(6, pn_dUp, pn_dDown );
		dCheck[i]->update(screen);
	}
	for(i=0;i<MAX_PLAYERS;i++)
		for(j=0;j<MISSIONS;j++)
			yGame->setPlayerHaveM(i,j,false);
		
	for(i=0;i<MAX_PLAYERS;i++)
		for(j=0;j<MISSIONS_ALL;j++)
			mTxt[i][j]->update(screen);
		
	cpnText = new statictext(screen, CPNTEXT_X, CPNTEXT_Y, SHITEXT_SIZE, fn_font1.c_str() ,"Joni Valtanen or something");

	yGame->setTotalPlayers();
	for(i=0;i<MAX_DICES;i++)
		dCheck[i]->setCheck();
	
	bThrow->update( screen );
	bQuit->update( screen );
	for(i=0;i<MISSIONS;i++)
		bM[i]->update( screen );
	for(i=0;i<MAX_MTOTAL;i++)
		sM[i]->update( screen );

	yGame->setFirstPlayer();
	currentPlayer = yGame->getFirstPlayer();
	
	cpnText->updateValue( yGame->getName(yGame->getCurrentPlayer()) );
	cpnText->update( screen );
	
	
	currentRound=yGame->getRound();
	
	for(i=0; i < MAX_DICES;i++ )
		dCheck[i]->update( screen );
	
	while(game_quit2 < 1)
	{
		while(game_quit < 1) //double check
		{
#ifndef WIN32                        
			usleep(USLEEP);
#else
            Sleep(1);
#endif
			while(SDL_PollEvent(&event))
			{
				switch(event.type)
				{
					case SDL_QUIT:
						SDL_BlitSurface(screen, NULL, tmp, NULL); 
						drawScreen(pn_quit.c_str());
						if(handleQuit()==QUIT)
						{
							game_quit = WQUIT;
						}
						//game_quit = WQUIT;
						break;
					case SDL_MOUSEBUTTONDOWN:
						if(!disabled)
							bThrow->isPressed(event.button.x, event.button.y, screen);
						bQuit->isPressed(event.button.x, event.button.y, screen);
					
						if(!firstThrow)
						{
							currentPlayer = yGame->getCurrentPlayer();
							for(i=0;i<MISSIONS;i++)
								if(!yGame->getPlayerHaveM(currentPlayer, i))
									bM[i]->isPressed(event.button.x, event.button.y, screen);
						}
						break; // end SDL_MOUSEBUTTONDOWN
					case SDL_MOUSEBUTTONUP:
						if(!firstThrow)
							for(i=0; i < MAX_DICES;i++ )
								dCheck[i]->onMouseClick(event.button.x, event.button.y, screen);
							
						//if player is finishing round
						for(i=0;i<MISSIONS;i++)
							if( bM[i]->isReleased(event.button.x, event.button.y, screen) )
								{
									currentPlayer = yGame->getCurrentPlayer();
									//i=ONE,TWO...
									for(j=0;j<MAX_DICES;j++)
									{
										gDice[j]=dCheck[j]->getValue();
										//cout << gDice[j] << "; " << endl;
									}									
									if(i<SIX)
										hc = testing->handleChoise(i+ONE,gDice );
									else
										hc = testing->handleChoise(i+THREE,gDice); //for simplicity
									
									//no more same choise
									yGame->setPlayerHaveM(currentPlayer, i,true);
									yGame->setPlayerM(currentPlayer, i, hc);
									//cout << "i:" << i << endl;

									total = yGame->getPlayerTotal(currentPlayer); //PlayerM(currentPlayer, j);
									utotal = yGame->getPlayerUTotal(currentPlayer);

									// update points to the game
									sprintf(result,"%d",hc);
									sprintf(cTotal,"%d",total);
									sprintf(cUTotal,"%d",utotal);
									
									if(i<SIX)
									{
										delete mTxt[currentPlayer][i+ONE];
										mTxt[currentPlayer][i+ONE] = new statictext(screen, (currentPlayer*DSTM_X+STM1_X), ((i+ONE)*DM+STM1_Y),ITEXT3_SIZE,fn_font1.c_str(), result);
										mTxt[currentPlayer][i+ONE]->update(screen);
									}
									else									
									{
										delete mTxt[currentPlayer][i+THREE];
										mTxt[currentPlayer][i+THREE] = new statictext(screen, (currentPlayer*DSTM_X+STM1_X), ((i+THREE)*DM+STM1_Y),ITEXT3_SIZE,fn_font1.c_str(), result);
										mTxt[currentPlayer][i+THREE]->update(screen);
									}

									
if(utotal>=BONUS_LINE)
									{
										yGame->setBonus(currentPlayer);
										delete mTxt[currentPlayer][BONUS];
										mTxt[currentPlayer][BONUS] = new statictext(screen, (currentPlayer*DSTM_X+STM1_X), ((BONUS)*DM+STM1_Y),ITEXT2_SIZE,fn_font1.c_str(), "50");
										mTxt[currentPlayer][BONUS]->update(screen);
										
										total = yGame->getPlayerTotal(currentPlayer); //PlayerM(currentPlayer, j);
										utotal = yGame->getPlayerUTotal(currentPlayer);
							
										sprintf(cTotal,"%d",total);
										sprintf(cUTotal,"%d",utotal);
									}
									delete mTxt[currentPlayer][MISSIONS_ALL-1];
									mTxt[currentPlayer][MISSIONS_ALL-1] = new statictext(screen, (currentPlayer*DSTM_X+STM1_X), ((MISSIONS_ALL-1)*DM+STM1_Y),ITEXT1_SIZE,fn_font1.c_str(), cTotal);
									mTxt[currentPlayer][MISSIONS_ALL-1]->update(screen);

									delete mTxt[currentPlayer][UTOTAL];
									mTxt[currentPlayer][UTOTAL] = new statictext(screen, (currentPlayer*DSTM_X+STM1_X), ((UTOTAL)*DM+STM1_Y),ITEXT2_SIZE,fn_font1.c_str(), cUTotal);
									mTxt[currentPlayer][UTOTAL]->update(screen);
									
									yGame->changePlayer();
									currentPlayer = yGame->getCurrentPlayer();
									for(j=0; j < MAX_DICES;j++ )
										dCheck[j]->updateValue(6, pn_dUp, pn_dDown );
									firstThrow=true; // players first throw
									

									// if player has throwed 3 times
									if(disabled=true)
									{
										currentRound = yGame->getRound();

										delete cpnText;
										cpnText = new statictext(screen, CPNTEXT_X, CPNTEXT_Y, SHITEXT_SIZE, fn_font1.c_str() ,yGame->getName(currentPlayer));
										cpnText->update( screen );
										for(j=0;j<MAX_DICES;j++)
										{
											dCheck[j]->setCheck();
											dCheck[j]->update( screen );
										}
										disabled=false;
									}//if(disa
								}//if( bM[i...
							
						if( bThrow->isReleased(event.button.x, event.button.y, screen) )
						{
						
							// check what dices are checked and trow them
							for(i=0;i<MAX_DICES;i++)
								if(dCheck[i]->isChecked())
								{
									firstThrow=false;
									//if something is really throwed it's throw 
									
									// if player has throwed all rounds
									if(yGame->getPlayerRound()==1)
									{
										/*
										for(i=0;i<MAX_DICES;i++)
											dCheck[i]->disable();
										bThrow->disable();
										*/
										disabled=true; // forces to choose some
										
										//cout << "Choose your game!!" << endl;
									}
									//cout << "Disabled a: "<< disabled << endl;
									yGame->decPlayerRound(); // throwed=1 round lesser
						
									break; // ends because these are done only once in throw
								}

								// updates dices
								for(anim=0; anim < 5; anim++)
								{
									for(i=0;i<MAX_DICES;i++)
									{
										// only throwed are updated
										if(dCheck[i]->isChecked())
										{
											dCheck[i]->updateValue( yGame->rndDice(i), pn_dUp, pn_dDown );
											dCheck[i]->update( screen );
										}
									}
								}
								//
								//bThrow->update(screen);
							//sdl_quit = START;
						}
						else if( bQuit->isReleased(event.button.x, event.button.y, screen) )
						{
							SDL_BlitSurface(screen, NULL, tmp, NULL); 
							drawScreen(pn_quit.c_str());
							if(handleQuit()==QUIT)
							{
								game_quit = WQUIT;
							}
							//game_quit = QUIT;
						}
						break;		
					default:
						break;					
				}				
			}
			if(currentRound == 0)
			{
//				cout << "end of the game" << endl;
				for(i=0;i<MAX_PLAYERS;i++)
				{
					if(yGame->playerIsOnGame(i))
					{
						if(yGame->getPlayerTotal(i) > yHiscore->getScore(MAX_HISCORES-1))
						{
							yHiscore->setHiscore(yGame->getName(i),yGame->getPlayerTotal(i),MAX_HISCORES-1);
							toTheList=true;
				//			cout << "toTheList" << endl;
						}					
					}
				}
				game_quit = END;
			}
		} // while
		/*
		if( game->getRound() > 0)
		{
			drawScreen(const char* pic);
			game_quit2 = handleQuit();
			drawScreen(const char* pic);
		}
		else
		*/
		// show winner/game information
		if( yGame->getRound() == 0)
		{
			drawScreen(pn_winner.c_str());
			game_quit2 = handleWin();
		}
			//cout << "Wellcome to the outer limits!!!"<< endl;
			game_quit2 = QUIT;
	} // while

	delete testing;
	delete cpnText;

	//dices
	for(i=0;i<MAX_DICES;i++)
		delete dCheck[i];

	for(i=0;i>MAX_PLAYERS;i++)
	{
		for(j=0;j<MISSIONS_ALL;j++)
			delete mTxt[i][j];
	}
	for(i=0;i<MAX_MTOTAL;i++)
		delete sM[i];
	
	if(toTheList)
		yFile->writeHiscores();
//		cout << "Wellcome to the outerest limits!!!"<< endl;
	return game_quit;
}

// config screen
int mSDL::handleConfigScreen()
{
	int i=0;
	sPText = new statictext(screen, SPTEXT_X, SPTEXT_Y, SHITEXT_SIZE, fn_font1.c_str() ,"Names:");
	sGText = new statictext(screen, SPTEXT_X, SGTEXT_Y, SHITEXT_SIZE, fn_font1.c_str() ,"Graphics:");
	fsText = new statictext(screen, FSTEXT_X, FSTEXT_Y, ITEXT1_SIZE, fn_font1.c_str() ,"Fullscreen");

	sText[0] = new statictext(screen, STEXT1_X, STEXT1_Y, ITEXT1_SIZE,fn_font1.c_str(), "Player1: ");
	sText[1] = new statictext(screen, STEXT1_X, STEXT2_Y, ITEXT1_SIZE, fn_font1.c_str(), "Player2: ");
	sText[2] = new statictext(screen, STEXT1_X, STEXT3_Y, ITEXT1_SIZE, fn_font1.c_str(), "Player3: ");
	sText[3] = new statictext(screen, STEXT1_X, STEXT4_Y, ITEXT1_SIZE, fn_font1.c_str(), "Player4: ");

	check[0] = new checkbox(screen, CHECK1_X, CHECK1_Y, pn_checkUp.c_str(), pn_checkDown.c_str(), false );
	check[1] = new checkbox(screen, CHECK1_X, CHECK2_Y, pn_checkUp.c_str(), pn_checkDown.c_str(), false );
	check[2] = new checkbox(screen, CHECK1_X, CHECK3_Y, pn_checkUp.c_str(), pn_checkDown.c_str(), false );
	check[3] = new checkbox(screen, CHECK1_X, CHECK4_Y, pn_checkUp.c_str(), pn_checkDown.c_str(), false );

	fsCheck = new checkbox(screen, FSCHECK_X, FSCHECK_Y, pn_checkUp.c_str(), pn_checkDown.c_str(), false );

	char name[MAX_PLAYERS][MAX_TEXT_REALLY];
	bool checked[MAX_PLAYERS+1];
	int ichecked[MAX_PLAYERS+1];
	
	
	for(i=0; i< MAX_PLAYERS; i++)
	{
		iText[i]->setText(yGame->getName(i));
		if(yGame->playerIsOnGame(i))
			check[i]->setCheck();
		strcpy(name[i],iText[i]->getText());
		checked[i]=check[i]->isChecked();
	}	
	if(yGame->getFullscreen())
		fsCheck->setCheck();
	
	checked[MAX_PLAYERS]=fsCheck->isChecked();

	bOK->update( screen );
	bCancel->update( screen );
	sPText->update( screen );
	sGText->update( screen );
	fsText->update( screen );
	
	fsCheck->update( screen );

	for(i=0; i<MAX_PLAYERS; i++)
	{
		iText[i]->update( screen );
		sText[i]->update( screen );
		check[i]->update( screen );
	}

	int config_quit=0;
	
	while(config_quit < 1)
	{
#ifndef WIN32                        
        usleep(USLEEP);
#else
        Sleep(1);
#endif
			for(i=0;i<MAX_PLAYERS;i++)
				iText[i]->isActive(screen);
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					SDL_BlitSurface(screen, NULL, tmp, NULL); 
					drawScreen(pn_quit.c_str());
					if(handleQuit()==QUIT)
					{
						config_quit = WQUIT;
					}

					break;
				case SDL_MOUSEBUTTONDOWN:
					bCancel->isPressed(event.button.x, event.button.y, screen);
					bOK->isPressed(event.button.x, event.button.y, screen);				
					break;
				case SDL_MOUSEBUTTONUP:
					fsCheck->onMouseClick(event.button.x, event.button.y, screen);
					for(i=0;i<MAX_PLAYERS;i++)
					{
						check[i]->onMouseClick(event.button.x, event.button.y, screen);
						iText[i]->onMouseClick(event.button.x, event.button.y, screen);
					}
					if( bOK->isReleased(event.button.x, event.button.y, screen) )
					{
						//saveChanges to yGame
						for(i=0;i<MAX_PLAYERS;i++)
						{
							if( hiText[i] != NULL )
							{
								delete hiText[i];
								delete hiText2[i];
								hiText[i]=NULL;
							}
	
							if(check[i]->isChecked())
								ichecked[i] = 1;
							else
								ichecked[i] = 0;
							strcpy(name[i],iText[i]->getText());
							//cout << name[i] << endl;
						}

						yGame->setConfig((int)fsCheck->isChecked(),ichecked,(const  char *)name);
						config_quit = OK;
					}
					if( bCancel->isReleased(event.button.x, event.button.y, screen) )
					{
						//get old values
						for(i=0; i< MAX_PLAYERS; i++)
						{
							iText[i]->setText(name[i]);
							if(checked[i]!=check[i]->isChecked())
								check[i]->toggleCheck();
						}
						config_quit = QUIT;
					}
				
					break;		
				case SDL_KEYDOWN:
					for(i=0;i<MAX_PLAYERS;i++)
						iText[i]->edit(&event.key, screen);

					break;		
				default:
					break;					
			}				
		}			
	}

	//yGame->setConfig((int)fsCheck->isChecked(),int *po,const  char *pn);
	for(i=0;i<MAX_PLAYERS;i++)
	{
		delete sText[i];
		delete check[i];
	}
	delete fsCheck;

	delete sPText;
	delete sGText;
	delete fsText;

	return config_quit;
}

// asks are player really quitting
int mSDL::handleQuit()
{
	int quit_quit=0;

	bOK->update( screen );
	bCancel->update( screen );
	
	//SDL_BlitSurface(quit);
	
	while(quit_quit < 1)
	{
#ifndef WIN32
		usleep(USLEEP);
#else
        Sleep(1);
#endif
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_MOUSEBUTTONDOWN:
					bCancel->isPressed(event.button.x, event.button.y, screen);
					bOK->isPressed(event.button.x, event.button.y, screen);				
					break;
				case SDL_MOUSEBUTTONUP:
					if( bOK->isReleased(event.button.x, event.button.y, screen) )
					{
						quit_quit = QUIT;
					}
					if( bCancel->isReleased(event.button.x, event.button.y, screen) )
					{
						quit_quit = CANCEL;
					}
				
					break;		
				default:
					break;					
			}				
		}			
	}
	if(quit_quit==CANCEL)
	{
		SDL_BlitSurface(tmp, NULL, screen, NULL);
		SDL_UpdateRect(screen,0,0,0,0);
		quit_quit=0;		
	}
	return quit_quit;
}

/*
	Shows who won and totalpoints of all players
	FIXME: places
*/
int mSDL::handleWin()
{
	int i,win,j=0;
	int win_quit=0;
	int total[MAX_PLAYERS];
	char cTotal[MAX_PLAYERS][MAX_TEXT];
	string winner;
	statictext* stPlayers[MAX_PLAYERS];
	statictext* stPlayersPoints[MAX_PLAYERS];
	
	for(i=0;i<MAX_PLAYERS;i++)
	{
		if(yGame->playerIsOnGame(i))
		{
			total[i] = yGame->getPlayerTotal(i);
			sprintf(cTotal[i],"%d",total[i]);
			stPlayers[i] = new statictext(screen,100,(j*30)+10,ITEXT1_SIZE, fn_font1.c_str(), yGame->getName(i));
			stPlayers[i]->update(screen);
			//j++;
			stPlayersPoints[i] = new statictext(screen,40,(j*30)+10,ITEXT1_SIZE, fn_font1.c_str(), cTotal[i]);
			stPlayersPoints[i]->update(screen);
			j++;
		}
	}//end for
	
	win = 0;
	for(i=0;i<MAX_PLAYERS;i++)
	{
		for(j=0;j<MAX_PLAYERS;j++)
		{
			if(total[win] < total[j])
				win = j;			
		}			
	}
	string winnerbeg("Winner is ");
	string winnerend("!!!");
	
	winner = winnerbeg + yGame->getName(win) + winnerend;
	statictext* sWinner = new statictext(screen, 300,270,SHITEXT_SIZE, fn_font1.c_str(),(char *)winner.c_str());
	sWinner->update(screen);
	bOK->update( screen );
	
	while(win_quit < 1)
	{
#ifndef WIN32
		usleep(USLEEP);
#else
        Sleep(1);
#endif
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_MOUSEBUTTONDOWN:
					bOK->isPressed(event.button.x, event.button.y, screen);				
					break;
				case SDL_MOUSEBUTTONUP:
					if( bOK->isReleased(event.button.x, event.button.y, screen) )
					{
						win_quit = QUIT;
					}
					break;		
				default:
					break;					
			}				
		}			
	}

	for(i=0;i<MAX_PLAYERS;i++)
	{
		if(yGame->playerIsOnGame(i))
		{
			delete stPlayers[i];
			delete stPlayersPoints[i];
		}
	}//end for

	delete sWinner;
	
	return win_quit;
}

void mSDL::drawHiscore( int score, char* name, int i )
{
	char cScore[MAX_TEXT],number[MAX_TEXT];
	sprintf(cScore,"%d",score);
	sprintf(number,"%d.",i+1);

	
	if( hiText[i] != NULL )
	{
		delete hiText[i];
		delete hiText2[i];
//		delete hiText0[i];
		hiText[i]=NULL;
	}
	
/*	hiText0[i] = new statictext(screen, HITEXT_X, (i*(ITEXT1_SIZE))+HITEXT_Y, ITEXT1_SIZE,fn_font1.c_str(), number);
	hiText0[i]->update(screen);	*/
	hiText[i] = new statictext(screen, HITEXT_X, (i*(ITEXT1_SIZE))+HITEXT_Y, ITEXT1_SIZE,fn_font1.c_str(), cScore);
	hiText[i]->update(screen);	
	hiText2[i] = new statictext(screen, HITEXT_X+40, (i*(ITEXT1_SIZE))+HITEXT_Y, ITEXT1_SIZE,fn_font1.c_str(), name);
	hiText2[i]->update(screen);	
	
//	delete hiText[0];*/
//	delete hiText[1];
}
