//
// File: statictext.cc
// Statictext class for SDL.
//
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Tue Nov  2 16:29:22 2004
//
//
// GNU General Public Licence version 2 - Read COPYING from the package
//

#include "statictext.h"

#define FCR 0xff 
#define FCB 0xf0 
#define FCG 0xf0 
#define FCA 0xf0 

statictext::statictext()
{
	// TODO: put constructor code here
}

statictext::statictext( SDL_Surface* destination, int x_pos, int y_pos, int tsize,const char* font_name, char* text)
{
	first_time=true;
	SDL_Color* fc;
	
	dst = destination;
	
	fontcolor.r = FCR;
	fontcolor.g = FCG;
	fontcolor.b = FCB;
	fontcolor.unused = FCA;

	fc = &fontcolor;

	dstrect.x = x_pos;
	dstrect.y = y_pos;

	TTF_Init();

	font=TTF_OpenFont(font_name, tsize);
	TTF_SetFontStyle(font, TTF_STYLE_NORMAL);
	
	textsurface = TTF_RenderText_Blended( font, text, *fc);
	back = TTF_RenderText_Blended( font, text, *fc); // same size

	dstrect.w = textsurface->w;
	dstrect.h = textsurface->h;

	SDL_BlitSurface(destination, &dstrect, back, NULL);

}

statictext::~statictext()
{
	if(back!=NULL)
		SDL_BlitSurface(back, NULL, dst, &dstrect);
	SDL_UpdateRect(dst, dstrect.x, dstrect.y, dstrect.w, dstrect.h );

	SDL_FreeSurface(textsurface);
	SDL_FreeSurface(back);
	TTF_CloseFont(font);
	//marby something wrong with my sdl_ttf framework
#ifndef MACOSX
	TTF_Quit();
#endif
}

void statictext::update(SDL_Surface* destination)
{
	if(back!=NULL)
		SDL_BlitSurface(back, NULL, destination, &dstrect);
	SDL_UpdateRect(destination, dstrect.x,	dstrect.y, dstrect.w, dstrect.h );

	SDL_BlitSurface( textsurface, NULL, destination, &dstrect);
	SDL_UpdateRect(destination, dstrect.x,	dstrect.y, dstrect.w, dstrect.h );
}


void statictext::updateValue(char *cValue)
{
	SDL_Color* fc;

	/*if(back!=NULL)
		SDL_BlitSurface(back, NULL, dst, &dstrect);
	SDL_UpdateRect(dst, dstrect.x, dstrect.y, dstrect.w, dstrect.h );
	*/
	
	SDL_FreeSurface(textsurface);
	
	fontcolor.r = FCR;
	fontcolor.g = FCG;
	fontcolor.b = FCB;
	fontcolor.unused = FCA;

	fc = &fontcolor;

	textsurface = TTF_RenderText_Blended( font, cValue, *fc);

	dstrect.w = textsurface->w;
	dstrect.h = textsurface->h;

}
