//
// File: testresult.cc
// Created by: Joni Valtanen <jvaltane@lpt.fi>
// Created on: Mon Nov 15 12:30:00 2004
//

#include "testresult.h"


testresult::testresult()
{
	// TODO: put constructor code here
}


testresult::~testresult()
{
	// TODO: put destructor code here
}

//tests results
//in: choise, dices
//out: points
int testresult::handleChoise(int choise, int dice[MAX_DICES])
{
	int i;
	int sum=0; //to return points
	int sum2=0; //to hut, house and tower 

#ifdef DEBUG	
	cout << "choise:" << choise << endl;
	cout << "3PAIRS: " << THREEPAIRS << endl;
#endif
	
	getSame(dice); // some kind of sort not really button make things easier
	
	switch(choise)
	{
		case ONE:
			sum = val[0]*ONE;
			break;
		case TWO:
			sum = val[1]*TWO;
			break;
		case THREE:
			sum = val[2]*THREE;
			break;
		case FOUR:
			sum = val[3]*FOUR;
			break;
		case FIVE:
			sum = val[4]*FIVE;
			break;
		case SIX:
			sum = val[5]*SIX;
			break;
		case PAIR:
			sum = testSame(2);
			break;
		case TWOPAIRS:
			sum = testPairs(2); //in howmany pairs
			break;
		case THREEPAIRS:
			sum = testPairs(3);
			break;
 		case THREEKIND:
			sum = testSame(3);
			break;
		case FOURKIND:
			sum = testSame(4);
			break;
		case FIVEKIND:
			sum = testSame(5);
			break;
		case SMALLSTRAIGHT:
			if( val[0]>0 && val[1]>0 && val[2]>0 && val[3]>0 && val[4]>0)
				sum = 15;				
			break;
		case LARGESTRAIGHT:
			if( val[1]>0 && val[2]>0 && val[3]>0 && val[4]>0 && val[5]>0 )
				sum = 20;				
			break;
		case FULLSTRAIGHT:
			if( val[0]>0 && val[1]>0 && val[2]>0 && val[3]>0 && val[4]>0 && val[5]>0 )
				sum = 21;				
			break;
		case HUT:
			sum = testSame(3);
			sum2 = testSameFrom(sum/3, 2);
			if(sum2>0 && sum>0)
				sum = sum + sum2;
			else
				sum=0;
			break;
		case HOUSE:
			sum = testSame(3);
			sum2 = testSameFrom(sum/3, 3);
			if(sum2>0 && sum>0)
				sum = sum + sum2;
			else
				sum=0;
			break;
		case TOWER:
			sum = testSame(4);
			sum2 = testSameFrom(sum/4, 2);
			if(sum2>0 && sum>0)
				sum = sum + sum2;
			else
				sum=0;
			break;
		case CHANGE:
			for(i=0;i<MAX_DICES;i++)
				sum += dice[i];
			break;
		case YATZY:
			sum = testSame(6);
			break;
		default:
			sum = 0;
			break;
				
	}
	return sum;
}

//tests same numbers (1-6)
//in: choise, dices
//out: points
void testresult::getSame(int dice[MAX_DICES])
{
	int i;

	
	for(i=0;i<MAX_DICES;i++)
		val[i]=0;
	
	for(i=0;i<MAX_DICES;i++)
		if(dice[i]==ONE)
			val[0]++;
	for(i=0;i<MAX_DICES;i++)
		if(dice[i]==TWO)
			val[1]++;
	for(i=0;i<MAX_DICES;i++)
		if(dice[i]==THREE)
			val[2]++;
	for(i=0;i<MAX_DICES;i++)
		if(dice[i]==FOUR)
			val[3]++;
	for(i=0;i<MAX_DICES;i++)
		if(dice[i]==FIVE)
			val[4]++;
	for(i=0;i<MAX_DICES;i++)
		if(dice[i]==SIX)
			val[5]++;

}

// tests same numbers from biggest to lowest
//
// in: how many dices have to bee same
// out: points
int testresult::testSame(int i)
{
	int sum=0;
	int j;

	for(j=(MAX_DICES-1);j >= 0;j--)
	{
		if(val[j]>=i)
		{
			sum=i*(j+1);
			if(i==6)
				sum=100; // for yatzee
			break;
		}
	}
	
	return sum;
}

/*
	checks pairs

	in: how many pairs
	out: points
*/
int testresult::testPairs(int i)
{
	int j,k=0;
	int sum=0;
	bool test[3];
	
	for(j=0;j<3;j++)
		test[j]=false;
	
	for(j=(MAX_DICES-1); j>= 0; j--)
	{
		if(val[j]>1)
		{
			sum = sum + ((j+1)*2);
			test[k] = true;
			k++;
#ifdef DEBUG	
			cout << "k: " << k << endl;
			cout << "i: " << k << endl;
#endif
			if(k==i)
			{
#ifdef DEBUG	
				cout << "break" << endl;
#endif
				break;
			}
		}
	}
	
#ifdef DEBUG	
	cout << "sum: " << sum << endl;
	cout << "test0: " << test[0] << endl;
	cout << "test1: " << test[1] << endl;
	cout << "test2: " << test[2] << endl;
#endif
	
	if(test[i-1])
		return sum;	
	
	return 0;
}

// tests same numbers from wanted to lowest
//
// in: where to start, how many dices have to bee same
// out: points
int testresult::testSameFrom(int k, int i)
{
	int sum=0;
	int j;

	for(j=(MAX_DICES-1);j >= 0;j--)
	{
		if(val[j]>=i && &val[j] != &val[k-1])
		{
			sum=i*(j+1);
			break;
		}
	}
	
	return sum;
}
